-- | Infix operators for construction of legacy plain text paragraphs
-- with readable code.
--
-- Example construction:
--
-- > let en = (,) defaultSpanOptions { spanLanguage = "en" }
-- >     ja = (,) defaultSpanOptions { spanLanguage = "ja" }
-- > in "ignored prefix" |< en "one two " >|< ja "三四" >| "ignored suffix"
--
-- Special syntax for paragraphs with no contents:
--
-- > "ignored prefix" |<>| "ignored suffix"
module Data.Text.ParagraphLayout.ParagraphConstruction
{-# DEPRECATED "Use \"Data.Text.ParagraphLayout.Rich\" instead." #-}
    ( (>|)
    , (>|<)
    , (|<)
    , (|<>|)
    )
where

import Data.Text.ParagraphLayout.Internal.ParagraphConstruction
